package agent

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"
	"bdqr-server/app/main/api/internal/logic/agent"
	"bdqr-server/app/main/api/internal/svc"
	"bdqr-server/app/main/api/internal/types"
	"bdqr-server/common/result"
	"bdqr-server/pkg/lzkit/validator"
)

func GenerateInviteCodeHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.GenerateInviteCodeReq
		if err := httpx.Parse(r, &req); err != nil {
			result.ParamErrorResult(r, w, err)
			return
		}
		if err := validator.Validate(req); err != nil {
			result.ParamValidateErrorResult(r, w, err)
			return
		}
		l := agent.NewGenerateInviteCodeLogic(r.Context(), svcCtx)
		resp, err := l.GenerateInviteCode(&req)
		result.HttpResult(r, w, resp, err)
	}
}
